<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.18.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Physical Problem &mdash; cflowpy Jule 2023 documentation</title>
      <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="_static/jquery.js"></script>
        <script src="_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
        <script src="_static/doctools.js"></script>
        <script src="_static/sphinx_highlight.js"></script>
    <script src="_static/js/theme.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Pipe flow" href="PhysicalProblems/pipe_flow.html" />
    <link rel="prev" title="Grid" href="grid.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="index.html" class="icon icon-home">
            cflowpy
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">cflowpy:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="tutorial.html">Tutorial</a></li>
<li class="toctree-l1"><a class="reference internal" href="grid.html">Grid</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">Physical Problem</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#constructor">Constructor</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#src.PhysicalProblem.__init__"><code class="docutils literal notranslate"><span class="pre">PhysicalProblem.__init__()</span></code></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#system-initialisation">System initialisation</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#src.PhysicalProblem.initialize_system"><code class="docutils literal notranslate"><span class="pre">PhysicalProblem.initialize_system()</span></code></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#boundary-conditions">Boundary Conditions</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#src.PhysicalProblem.apply_bcs_velocity"><code class="docutils literal notranslate"><span class="pre">PhysicalProblem.apply_bcs_velocity()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="#src.PhysicalProblem.apply_bcs_pressure"><code class="docutils literal notranslate"><span class="pre">PhysicalProblem.apply_bcs_pressure()</span></code></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#subclasses">Subclasses</a><ul>
<li class="toctree-l3"><a class="reference internal" href="PhysicalProblems/pipe_flow.html">Pipe flow</a></li>
<li class="toctree-l3"><a class="reference internal" href="PhysicalProblems/pipe_flow.html#pressure-driven-pipe-flow">Pressure driven pipe flow</a></li>
<li class="toctree-l3"><a class="reference internal" href="PhysicalProblems/pipe_with_a_backward_facing_step.html">Pipe with a backward facing step</a></li>
<li class="toctree-l3"><a class="reference internal" href="PhysicalProblems/cavity_flow.html">Cavity flow</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="integrator.html">Integrator</a></li>
<li class="toctree-l1"><a class="reference internal" href="system.html">Solving the incompressible Navier-Stokes Equation</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="index.html">cflowpy</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="index.html" class="icon icon-home" aria-label="Home"></a></li>
      <li class="breadcrumb-item active">Physical Problem</li>
      <li class="wy-breadcrumbs-aside">
            <a href="_sources/physical_problem.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="physical-problem">
<h1>Physical Problem<a class="headerlink" href="#physical-problem" title="Permalink to this heading"></a></h1>
<div class="line-block">
<div class="line">The class <code class="docutils literal notranslate"><span class="pre">PhysicalProblem</span></code> is used as a base class
to implement <strong>any kind of physical problem.</strong></div>
</div>
<dl class="py class">
<dt class="sig sig-object py">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">src.</span></span><span class="sig-name descname"><span class="pre">PhysicalProblem</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">physical_problem</span></span></em><span class="sig-paren">)</span></dt>
<dd><p>Base class for all kind of physical problems.</p>
<p>This class is used as a parent class to different kinds of problems.
Each inheritant class should have the three Methods of this class.</p>
<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">physical_problem</span></span></dt>
<dd><p>Describes the physical problem one wants to work on.</p>
<dl class="field-list simple">
<dt class="field-odd">Type<span class="colon">:</span></dt>
<dd class="field-odd"><p>PhysicalProblem</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<section id="constructor">
<h2>Constructor<a class="headerlink" href="#constructor" title="Permalink to this heading"></a></h2>
<dl class="py method">
<dt class="sig sig-object py" id="src.PhysicalProblem.__init__">
<span class="sig-prename descclassname"><span class="pre">PhysicalProblem.</span></span><span class="sig-name descname"><span class="pre">__init__</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">physical_problem</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.PhysicalProblem.__init__" title="Permalink to this definition"></a></dt>
<dd><p>Constructor</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><p><strong>physical_problem</strong> (<em>type</em><em>[</em><em>PhysicalProblem</em><em>]</em>) – Subclass of PhysicalProblem</p>
</dd>
</dl>
</dd></dl>

</section>
<section id="system-initialisation">
<h2>System initialisation<a class="headerlink" href="#system-initialisation" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">The initial state of each problem is specified in <code class="docutils literal notranslate"><span class="pre">initialize_system</span></code>.</div>
<div class="line">If this is not further specialised in the child class the velocities and
the pressure are initiales to zero at all points and then the boundary
conditions are applied.</div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="src.PhysicalProblem.initialize_system">
<span class="sig-prename descclassname"><span class="pre">PhysicalProblem.</span></span><span class="sig-name descname"><span class="pre">initialize_system</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">u</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">v</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">p</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.PhysicalProblem.initialize_system" title="Permalink to this definition"></a></dt>
<dd><p>Creates the initial state of the problem.</p>
<p>By default, the boundary conditions are applied.
However, some of the subclasses can have a specific
starting point for the physical problem.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>u</strong> (<em>np.ndarray</em>) – Velocity in x-direction before applying the boundary conditions</p></li>
<li><p><strong>v</strong> (<em>np.ndarray</em>) – Velocity in y-direction before applying the boundary conditions</p></li>
<li><p><strong>p</strong> (<em>np.ndarray</em>) – Pressure field before applying the boundary conditions</p></li>
</ul>
</dd>
<dt class="field-even">Raises<span class="colon">:</span></dt>
<dd class="field-even"><p><strong>TypeError</strong> – If one of the inputs is no numpy ndarray</p>
</dd>
<dt class="field-odd">Returns<span class="colon">:</span></dt>
<dd class="field-odd"><p>Velocity in x and y-direction as well as the pressure after
applying the boundary conditions.</p>
</dd>
<dt class="field-even">Return type<span class="colon">:</span></dt>
<dd class="field-even"><p>np.ndarray, np.ndarray, np.ndarray</p>
</dd>
</dl>
</dd></dl>

</section>
<section id="boundary-conditions">
<h2>Boundary Conditions<a class="headerlink" href="#boundary-conditions" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">The boundary conditions are enforced after every iteration step in
Chorin’s projection method.</div>
<div class="line">It is possible to implement any kind of boundary conditions.</div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="src.PhysicalProblem.apply_bcs_velocity">
<span class="sig-prename descclassname"><span class="pre">PhysicalProblem.</span></span><span class="sig-name descname"><span class="pre">apply_bcs_velocity</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">u</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">v</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.PhysicalProblem.apply_bcs_velocity" title="Permalink to this definition"></a></dt>
<dd><p>Applies the boundary conditions for the velocities.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>u</strong> (<em>np.ndarray</em>) – Velocity in x-direction</p></li>
<li><p><strong>v</strong> (<em>np.ndarray</em>) – Velocity in y-direction</p></li>
</ul>
</dd>
<dt class="field-even">Raises<span class="colon">:</span></dt>
<dd class="field-even"><p><strong>TypeError</strong> – If one of the inputs is no numpy ndarray</p>
</dd>
<dt class="field-odd">Returns<span class="colon">:</span></dt>
<dd class="field-odd"><p>Velocities with applied boundary conditions</p>
</dd>
<dt class="field-even">Return type<span class="colon">:</span></dt>
<dd class="field-even"><p>np.ndarray, np.ndarray</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="src.PhysicalProblem.apply_bcs_pressure">
<span class="sig-prename descclassname"><span class="pre">PhysicalProblem.</span></span><span class="sig-name descname"><span class="pre">apply_bcs_pressure</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">p</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.PhysicalProblem.apply_bcs_pressure" title="Permalink to this definition"></a></dt>
<dd><p>Applies boundary conditions for the pressure field.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><p><strong>p</strong> (<em>np.ndarray</em>) – Pressure field</p>
</dd>
<dt class="field-even">Raises<span class="colon">:</span></dt>
<dd class="field-even"><p><strong>TypeError</strong> – If p is no numpy ndarray</p>
</dd>
<dt class="field-odd">Returns<span class="colon">:</span></dt>
<dd class="field-odd"><p>Pressure field with applied boundary conditions</p>
</dd>
<dt class="field-even">Return type<span class="colon">:</span></dt>
<dd class="field-even"><p>np.ndarray</p>
</dd>
</dl>
</dd></dl>

</section>
<section id="subclasses">
<h2>Subclasses<a class="headerlink" href="#subclasses" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">Yet, there are a few different Subclasses implemented, each defining
another physical problem.</div>
</div>
<div class="toctree-wrapper compound">
<p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="PhysicalProblems/pipe_flow.html">Pipe flow</a><ul>
<li class="toctree-l2"><a class="reference internal" href="PhysicalProblems/pipe_flow.html#constructor">Constructor</a></li>
<li class="toctree-l2"><a class="reference internal" href="PhysicalProblems/pipe_flow.html#system-initialisation">System initialisation</a></li>
<li class="toctree-l2"><a class="reference internal" href="PhysicalProblems/pipe_flow.html#boundary-conditions">Boundary Conditions</a></li>
<li class="toctree-l2"><a class="reference internal" href="PhysicalProblems/pipe_flow.html#expected-results">Expected Results</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="PhysicalProblems/pipe_flow.html#pressure-driven-pipe-flow">Pressure driven pipe flow</a><ul>
<li class="toctree-l2"><a class="reference internal" href="PhysicalProblems/pipe_flow.html#id1">Constructor</a></li>
<li class="toctree-l2"><a class="reference internal" href="PhysicalProblems/pipe_flow.html#id2">System initialisation</a></li>
<li class="toctree-l2"><a class="reference internal" href="PhysicalProblems/pipe_flow.html#id3">Boundary Conditions</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="PhysicalProblems/pipe_with_a_backward_facing_step.html">Pipe with a backward facing step</a><ul>
<li class="toctree-l2"><a class="reference internal" href="PhysicalProblems/pipe_with_a_backward_facing_step.html#constructor">Constructor</a></li>
<li class="toctree-l2"><a class="reference internal" href="PhysicalProblems/pipe_with_a_backward_facing_step.html#system-initialisation">System initialisation</a></li>
<li class="toctree-l2"><a class="reference internal" href="PhysicalProblems/pipe_with_a_backward_facing_step.html#boundary-conditions">Boundary Conditions</a></li>
<li class="toctree-l2"><a class="reference internal" href="PhysicalProblems/pipe_with_a_backward_facing_step.html#expected-results">Expected Results</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="PhysicalProblems/cavity_flow.html">Cavity flow</a><ul>
<li class="toctree-l2"><a class="reference internal" href="PhysicalProblems/cavity_flow.html#constructor">Constructor</a></li>
<li class="toctree-l2"><a class="reference internal" href="PhysicalProblems/cavity_flow.html#system-initialisation">System initialisation</a></li>
<li class="toctree-l2"><a class="reference internal" href="PhysicalProblems/cavity_flow.html#boundary-conditions">Boundary Conditions</a></li>
<li class="toctree-l2"><a class="reference internal" href="PhysicalProblems/cavity_flow.html#expected-results">Expected Results</a></li>
</ul>
</li>
</ul>
</div>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="grid.html" class="btn btn-neutral float-left" title="Grid" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="PhysicalProblems/pipe_flow.html" class="btn btn-neutral float-right" title="Pipe flow" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2023, Jan Habscheid.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>